#include <windows.h>
#include <string.h>
#include <ddeml.h>

BOOL (WINAPI *Ctl3dRegister)(HANDLE);
BOOL (WINAPI *Ctl3dAutoSubclass)(HANDLE);
BOOL (WINAPI *Ctl3dUnregister)(HANDLE);

HANDLE hInst;
HCONVLIST list;
DWORD inst;
HCONV conv;
HWND hDlg;
char application1[80];
char application2[80];
HSZ app;
char topic1[80];
char topic2[80];
HSZ top;
char item1[80];
char item2[80];
HSZ ite;
char buffer[1024];
HDDEDATA data;

HDDEDATA FAR PASCAL _export ClientCallBack(UINT type,UINT fmt,HCONV thisconv,HSZ s1,HSZ s2,HDDEDATA data,DWORD d1,DWORD d2)
{
    char service[80];

    switch(type)
    {
    case XTYP_UNREGISTER:
        DdeQueryString(inst,s1,service,sizeof(service),0);
        if(strcmp(service,application1)==0) PostMessage(hDlg,WM_USER+1,0,0L);
        return 0;
    case XTYP_DISCONNECT:
        if(conv==thisconv) PostMessage(hDlg,WM_USER+1,0,0L);
        return 0;
    }
    return 0;
}

BOOL FAR PASCAL _export AboutProc(HWND wnd,unsigned msg,WPARAM wParam,LPARAM lParam)
{
    switch(msg)
    {
    case WM_INITDIALOG:
        return TRUE;
    case WM_COMMAND:
        switch(wParam)
        {
        case 2:
            EndDialog(wnd,0);
            return TRUE;
        }
        break;
    }
    return FALSE;
}

BOOL FAR PASCAL _export DlgProc(HWND wnd,unsigned msg,WPARAM wParam,LPARAM lParam)
{
    BOOL enable;
    HSZ s;
    DWORD size;
    CONVINFO info;
    HCONV x;
    HMENU hMenu;
    PAINTSTRUCT ps;

    switch(msg)
    {
    case WM_ERASEBKGND:
        return IsIconic(wnd);
    case WM_PAINT:
        if(IsIconic(wnd))
        {
            BeginPaint(wnd,&ps);
            DefWindowProc(wnd,WM_ICONERASEBKGND,(WORD)ps.hdc,0L);
            DrawIcon(ps.hdc,0,0,LoadIcon(hInst,MAKEINTRESOURCE(1)));
            EndPaint(wnd,&ps);
            return TRUE;
        }
        return FALSE;
    case WM_INITDIALOG:
        inst=0L;
        hDlg=wnd;
        hMenu=GetSystemMenu(wnd,FALSE);
        ChangeMenu(hMenu,0,NULL,0,MF_APPEND);
        ChangeMenu(hMenu,0,"A&bout...",999,MF_APPEND);
        if(DdeInitialize(&inst,ClientCallBack,APPCMD_CLIENTONLY,0L))
        {
            MessageBox(0,"DDE Test","Can not initialize DDEML",MB_ICONEXCLAMATION|MB_OK);
            EndDialog(wnd,0);
            return TRUE;
        }
        SendDlgItemMessage(wnd,100,CB_LIMITTEXT,sizeof(application1),0L);
        SendDlgItemMessage(wnd,101,CB_LIMITTEXT,sizeof(topic1),0L);
        SendDlgItemMessage(wnd,102,CB_LIMITTEXT,sizeof(item1),0L);
        SendDlgItemMessage(wnd,103,CB_LIMITTEXT,sizeof(buffer),0L);
        PostMessage(wnd,WM_USER,0,0L);
        return TRUE;
    case WM_USER+1: /* Disconnect */
        SetDlgItemText(wnd,100,"");
        /* fall thru */
    case WM_USER:
        enable=SendDlgItemMessage(wnd,100,WM_GETTEXTLENGTH,0,0L)>0;
        EnableWindow(GetDlgItem(wnd,101),enable);
        if(enable)
        {
            enable=SendDlgItemMessage(wnd,101,WM_GETTEXTLENGTH,0,0L)>0;
        }
        else
        {
            SetDlgItemText(wnd,101,"");
        }
        EnableWindow(GetDlgItem(wnd,102),enable);
        EnableWindow(GetDlgItem(wnd,103),enable);
        if(enable)
        {
            enable=SendDlgItemMessage(wnd,102,WM_GETTEXTLENGTH,0,0L)>0;
        }
        else
        {
            SetDlgItemText(wnd,102,"");
        }
        EnableWindow(GetDlgItem(wnd,4),enable);
        EnableWindow(GetDlgItem(wnd,5),enable);
        if(enable)
        {
            enable=SendDlgItemMessage(wnd,103,WM_GETTEXTLENGTH,0,0L)>0;
        }
        else
        {
            SetDlgItemText(wnd,103,"");
        }
        EnableWindow(GetDlgItem(wnd,3),enable);
        return TRUE;
    case WM_SYSCOMMAND:
        if(wParam==999)
        {
            DialogBox(hInst,MAKEINTRESOURCE(2),wnd,AboutProc);
            return TRUE;
        }
        return FALSE;
    case WM_COMMAND:
        switch(wParam)
        {
        case 100: /* Application */
            switch(HIWORD(lParam))
            {
            case CBN_DROPDOWN:
                SendMessage((HWND)LOWORD(lParam),CB_RESETCONTENT,0,0L);
                list=DdeConnectList(inst,0,0,0,0);
                x=0;
                while(x=DdeQueryNextServer(list,x))
                {
                    DdeQueryConvInfo(x,QID_SYNC,&info);
                    DdeQueryString(inst,info.hszSvcPartner,buffer,sizeof(buffer),0);
                    if(SendMessage((HWND)LOWORD(lParam),CB_FINDSTRINGEXACT,(WPARAM)-1,(LONG)(LPSTR)buffer)==LB_ERR)
                    {
                        SendMessage((HWND)LOWORD(lParam),CB_ADDSTRING,0,(LONG)(LPSTR)buffer);
                    }
                }
                DdeDisconnectList(list);
                return TRUE;
            case CBN_SELCHANGE:
            case CBN_EDITCHANGE:
                PostMessage(wnd,WM_USER,0,0L);
                return TRUE;
            }
            break;
        case 101: /* Topic */
            switch(HIWORD(lParam))
            {
            case CBN_DROPDOWN:
                if(GetDlgItemText(wnd,100,buffer,sizeof(buffer))<1)
                {
                    return TRUE;
                }
                s=DdeCreateStringHandle(inst,buffer,0);
                SendMessage((HWND)LOWORD(lParam),CB_RESETCONTENT,0,0L);
                list=DdeConnectList(inst,s,0,0,0);
                x=0;
                while(x=DdeQueryNextServer(list,x))
                {
                    DdeQueryConvInfo(x,QID_SYNC,&info);
                    DdeQueryString(inst,info.hszTopic,buffer,sizeof(buffer),0);
                    if(SendMessage((HWND)LOWORD(lParam),CB_FINDSTRINGEXACT,(WPARAM)-1,(LONG)(LPSTR)buffer)==LB_ERR)
                    {
                        SendMessage((HWND)LOWORD(lParam),CB_ADDSTRING,0,(LONG)(LPSTR)buffer);
                    }
                }
                DdeDisconnectList(list);
                DdeFreeStringHandle(inst,s);
                return TRUE;
            case CBN_SELCHANGE:
            case CBN_EDITCHANGE:
                PostMessage(wnd,WM_USER,0,0L);
                return TRUE;
            }
            break;
        case 102: /* Item */
            switch(HIWORD(lParam))
            {
            case CBN_SELCHANGE:
            case CBN_EDITCHANGE:
                PostMessage(wnd,WM_USER,0,0L);
                return TRUE;
            }
            break;
        case 103: /* Data */
            switch(HIWORD(lParam))
            {
            case CBN_SELCHANGE:
            case CBN_EDITCHANGE:
                PostMessage(wnd,WM_USER,0,0L);
                return TRUE;
            }
            break;
        case 2: /* Exit */
            if(conv) DdeDisconnect(conv);
            DdeUninitialize(inst);
            EndDialog(wnd,0);
            return TRUE;
        case 3: /* Poke */
        case 4: /* Peek */
            if(GetDlgItemText(wnd,102,item2,sizeof(item2))<1)
            {
                MessageBox(wnd,"DDE Test","Item name required",MB_ICONEXCLAMATION|MB_OK);
                return TRUE;
            }
            if(strcmp(item1,item2)!=0)
            {
                if(ite) DdeFreeStringHandle(inst,ite);
                strcpy(item1,item2);
                ite=DdeCreateStringHandle(inst,item1,0);
            }
            /* fall thru */
        case 5: /* Execute */
            GetDlgItemText(wnd,102,buffer,sizeof(buffer));
            if(SendDlgItemMessage(wnd,102,CB_FINDSTRINGEXACT,(WPARAM)-1,(LONG)(LPSTR)buffer)==LB_ERR)
            {
                SendDlgItemMessage(wnd,102,CB_ADDSTRING,0,(LONG)(LPSTR)buffer);
            }
            if(GetDlgItemText(wnd,100,application2,sizeof(application2))<1)
            {
                MessageBox(wnd,"DDE Test","Application name required",MB_ICONEXCLAMATION|MB_OK);
                return TRUE;
            }
            if(GetDlgItemText(wnd,101,topic2,sizeof(topic2))<1)
            {
                MessageBox(wnd,"DDE Test","Topic name required",MB_ICONEXCLAMATION|MB_OK);
                return TRUE;
            }
            if(conv==0||strcmp(application1,application2)!=0||strcmp(topic1,topic2)!=0)
            {
                if(conv) DdeDisconnect(conv);
                DdeFreeStringHandle(inst,app);
                DdeFreeStringHandle(inst,top);
                strcpy(application1,application2);
                strcpy(topic1,topic2);
                app=DdeCreateStringHandle(inst,application1,0);
                top=DdeCreateStringHandle(inst,topic1,0);
                conv=DdeConnect(inst,app,top,0);
            }
            if(conv) switch(wParam)
            {
            case 3: /* Poke */
                GetDlgItemText(wnd,103,buffer,sizeof(buffer));
                if(SendDlgItemMessage(wnd,103,CB_FINDSTRINGEXACT,(WPARAM)-1,(LONG)(LPSTR)buffer)==LB_ERR)
                {
                    SendDlgItemMessage(wnd,103,CB_ADDSTRING,0,(LONG)(LPSTR)buffer);
                }
                DdeClientTransaction(buffer,strlen(buffer)+1,conv,ite,CF_TEXT,XTYP_POKE,0,NULL);
                break;
            case 4: /* Peek */
                data=DdeClientTransaction(NULL,0,conv,ite,CF_TEXT,XTYP_REQUEST,0,NULL);
                if(data)
                {
                    if(DdeAccessData(data,&size))
                    {
                        if(size<sizeof(buffer))
                        {
                            DdeGetData(data,buffer,size,0);
                            buffer[(int)size]='\0';
                            SetDlgItemText(wnd,103,buffer);
                        }
                        DdeUnaccessData(data);
                    }
                    DdeFreeDataHandle(data);
                }
                else
                {
                    SetDlgItemText(wnd,103,"");
                }
                break;
            case 5: /* Execute */
                GetDlgItemText(wnd,102,buffer,sizeof(buffer));
                DdeClientTransaction(buffer,strlen(buffer)+1,conv,0,CF_TEXT,XTYP_EXECUTE,0,NULL);
                break;
            }
            else
            {
                MessageBox(wnd,"DDE Test","No connection established",MB_ICONEXCLAMATION|MB_OK);
            }
            return TRUE;
        }
        break;
    }
    return FALSE;
}

int PASCAL WinMain(HANDLE hThis,HANDLE hPrev,LPSTR lpszCmdLine,int nCmdShow)
{
    int i;
    HANDLE lib;

    hInst=hThis;
    i=SetErrorMode(SEM_NOOPENFILEERRORBOX);
    lib=LoadLibrary("ctl3dv2.dll");
    if(lib<32) LoadLibrary("ctl3d.dll");
    if(lib>=32)
    {
        (FARPROC)Ctl3dRegister=GetProcAddress(lib,"Ctl3dRegister");
        (FARPROC)Ctl3dAutoSubclass=GetProcAddress(lib,"Ctl3dAutoSubclass");
        (FARPROC)Ctl3dUnregister=GetProcAddress(lib,"Ctl3dUnregister");
        if(Ctl3dRegister) Ctl3dRegister(hInst);
        if(Ctl3dAutoSubclass) Ctl3dAutoSubclass(hInst);
    }
    SetErrorMode(i);
    i=DialogBox(hThis,MAKEINTRESOURCE(1),0,DlgProc);
    if(lib>=32)
    {
        if(Ctl3dUnregister) Ctl3dUnregister(hInst);
        FreeLibrary(lib);
    }
    return i;
}
